Makefile 8.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228
  1. # set the shell to bash always
  2. SHELL := /bin/bash
  3. # set make and shell flags to exit on errors
  4. MAKEFLAGS += --warn-undefined-variables
  5. .SHELLFLAGS := -euo pipefail -c
  6. ARCH = amd64 arm64
  7. BUILD_ARGS ?=
  8. # default target is build
  9. .DEFAULT_GOAL := all
  10. .PHONY: all
  11. all: $(addprefix build-,$(ARCH))
  12. # Image registry for build/push image targets
  13. IMAGE_REGISTRY ?= ghcr.io/external-secrets/external-secrets
  14. # Produce CRDs that work back to Kubernetes 1.11 (no version conversion)
  15. CRD_OPTIONS ?= "crd:trivialVersions=true"
  16. CRD_DIR ?= deploy/crds
  17. HELM_DIR ?= deploy/charts/external-secrets
  18. OUTPUT_DIR ?= bin
  19. # Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
  20. ifeq (,$(shell go env GOBIN))
  21. GOBIN=$(shell go env GOPATH)/bin
  22. else
  23. GOBIN=$(shell go env GOBIN)
  24. endif
  25. # check if there are any existing `git tag` values
  26. ifeq ($(shell git tag),)
  27. # no tags found - default to initial tag `v0.0.0`
  28. VERSION := $(shell echo "v0.0.0-$$(git rev-list HEAD --count)-g$$(git describe --dirty --always)" | sed 's/-/./2' | sed 's/-/./2')
  29. else
  30. # use tags
  31. VERSION := $(shell git describe --dirty --always --tags --exclude 'helm*' | sed 's/-/./2' | sed 's/-/./2')
  32. endif
  33. # ====================================================================================
  34. # Colors
  35. BLUE := $(shell printf "\033[34m")
  36. YELLOW := $(shell printf "\033[33m")
  37. RED := $(shell printf "\033[31m")
  38. GREEN := $(shell printf "\033[32m")
  39. CNone := $(shell printf "\033[0m")
  40. # ====================================================================================
  41. # Logger
  42. TIME_LONG = `date +%Y-%m-%d' '%H:%M:%S`
  43. TIME_SHORT = `date +%H:%M:%S`
  44. TIME = $(TIME_SHORT)
  45. INFO = echo ${TIME} ${BLUE}[ .. ]${CNone}
  46. WARN = echo ${TIME} ${YELLOW}[WARN]${CNone}
  47. ERR = echo ${TIME} ${RED}[FAIL]${CNone}
  48. OK = echo ${TIME} ${GREEN}[ OK ]${CNone}
  49. FAIL = (echo ${TIME} ${RED}[FAIL]${CNone} && false)
  50. # ====================================================================================
  51. # Conformance
  52. reviewable: generate helm.generate lint ## Ensure a PR is ready for review.
  53. @go mod tidy
  54. check-diff: reviewable ## Ensure branch is clean.
  55. @$(INFO) checking that branch is clean
  56. @test -z "$$(git status --porcelain)" || (echo "$$(git status --porcelain)" && $(FAIL))
  57. @$(OK) branch is clean
  58. # ====================================================================================
  59. # Golang
  60. .PHONY: test
  61. test: generate ## Run tests
  62. @$(INFO) go test unit-tests
  63. go test -race -v $(shell go list ./... | grep -v e2e) -coverprofile cover.out
  64. @$(OK) go test unit-tests
  65. .PHONY: test.e2e
  66. test.e2e: generate ## Run e2e tests
  67. @$(INFO) go test e2e-tests
  68. $(MAKE) -C ./e2e test
  69. @$(OK) go test unit-tests
  70. .PHONY: build
  71. build: $(addprefix build-,$(ARCH)) ## Build binary
  72. .PHONY: build-%
  73. build-%: generate ## Build binary for the specified arch
  74. @$(INFO) go build $*
  75. @CGO_ENABLED=0 GOOS=linux GOARCH=$* \
  76. go build -o '$(OUTPUT_DIR)/external-secrets-linux-$*' main.go
  77. @$(OK) go build $*
  78. lint.check: ## Check install of golanci-lint
  79. @if ! golangci-lint --version > /dev/null 2>&1; then \
  80. echo -e "\033[0;33mgolangci-lint is not installed: run \`\033[0;32mmake lint.install\033[0m\033[0;33m\` or install it from https://golangci-lint.run\033[0m"; \
  81. exit 1; \
  82. fi
  83. lint.install: ## Install golangci-lint to the go bin dir
  84. @if ! golangci-lint --version > /dev/null 2>&1; then \
  85. echo "Installing golangci-lint"; \
  86. curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOBIN) v1.42.1; \
  87. fi
  88. lint: lint.check ## Run golangci-lint
  89. @if ! golangci-lint run; then \
  90. echo -e "\033[0;33mgolangci-lint failed: some checks can be fixed with \`\033[0;32mmake fmt\033[0m\033[0;33m\`\033[0m"; \
  91. exit 1; \
  92. fi
  93. @$(OK) Finished linting
  94. fmt: lint.check ## Ensure consistent code style
  95. @go mod tidy
  96. @go fmt ./...
  97. @golangci-lint run --fix > /dev/null 2>&1 || true
  98. @$(OK) Ensured consistent code style
  99. generate: ## Generate code and crds
  100. @go run sigs.k8s.io/controller-tools/cmd/controller-gen object:headerFile="hack/boilerplate.go.txt" paths="./..."
  101. @go run sigs.k8s.io/controller-tools/cmd/controller-gen $(CRD_OPTIONS) paths="./..." output:crd:artifacts:config=$(CRD_DIR)
  102. # Remove extra header lines in generated CRDs
  103. @for i in $(CRD_DIR)/*.yaml; do \
  104. tail -n +3 <"$$i" >"$$i.bkp" && \
  105. cp "$$i.bkp" "$$i" && \
  106. rm "$$i.bkp"; \
  107. done
  108. @$(OK) Finished generating deepcopy and crds
  109. # ====================================================================================
  110. # Local Utility
  111. # This is for running out-of-cluster locally, and is for convenience.
  112. # For more control, try running the binary directly with different arguments.
  113. run: generate ## Run app locally (without a k8s cluster)
  114. go run ./main.go
  115. manifests: helm.generate ## Generate manifests from helm chart
  116. mkdir -p $(OUTPUT_DIR)/deploy/manifests
  117. helm template external-secrets $(HELM_DIR) -f deploy/manifests/helm-values.yaml > $(OUTPUT_DIR)/deploy/manifests/external-secrets.yaml
  118. crds.install: generate ## Install CRDs into a cluster. This is for convenience
  119. kubectl apply -f $(CRD_DIR)
  120. crds.uninstall: ## Uninstall CRDs from a cluster. This is for convenience
  121. kubectl delete -f $(CRD_DIR)
  122. # ====================================================================================
  123. # Helm Chart
  124. helm.docs: ## Generate helm docs
  125. @cd $(HELM_DIR); \
  126. docker run --rm -v $(shell pwd)/$(HELM_DIR):/helm-docs -u $(shell id -u) jnorwood/helm-docs:v1.5.0
  127. HELM_VERSION ?= $(shell helm show chart $(HELM_DIR) | grep 'version:' | sed 's/version: //g')
  128. helm.build: helm.generate ## Build helm chart
  129. @$(INFO) helm package
  130. @helm package $(HELM_DIR) --dependency-update --destination $(OUTPUT_DIR)/chart
  131. @mv $(OUTPUT_DIR)/chart/external-secrets-$(HELM_VERSION).tgz $(OUTPUT_DIR)/chart/external-secrets.tgz
  132. @$(OK) helm package
  133. helm.generate: helm.docs ## Copy crds to helm chart directory
  134. @cp $(CRD_DIR)/*.yaml $(HELM_DIR)/templates/crds/
  135. # Add helm if statement for controlling the install of CRDs
  136. @for i in $(HELM_DIR)/templates/crds/*.yaml; do \
  137. cp "$$i" "$$i.bkp" && \
  138. echo "{{- if .Values.installCRDs }}" > "$$i" && \
  139. cat "$$i.bkp" >> "$$i" && \
  140. echo "{{- end }}" >> "$$i" && \
  141. rm "$$i.bkp"; \
  142. done
  143. @$(OK) Finished generating helm chart files
  144. # ====================================================================================
  145. # Documentation
  146. .PHONY: docs
  147. docs: generate ## Generate docs
  148. $(MAKE) -C ./hack/api-docs build
  149. .PHONY: serve-docs
  150. serve-docs: ## Serve docs
  151. $(MAKE) -C ./hack/api-docs serve
  152. # ====================================================================================
  153. # Build Artifacts
  154. build.all: docker.build helm.build ## Build all artifacts (docker image, helm chart)
  155. docker.build: $(addprefix build-,$(ARCH)) ## Build the docker image
  156. @$(INFO) docker build
  157. @docker build . $(BUILD_ARGS) -t $(IMAGE_REGISTRY):$(VERSION)
  158. @$(OK) docker build
  159. docker.push: ## Push the docker image to the registry
  160. @$(INFO) docker push
  161. @docker push $(IMAGE_REGISTRY):$(VERSION)
  162. @$(OK) docker push
  163. # RELEASE_TAG is tag to promote. Default is promooting to main branch, but can be overriden
  164. # to promote a tag to a specific version.
  165. RELEASE_TAG ?= main
  166. SOURCE_TAG ?= $(VERSION)
  167. docker.promote: ## Promote the docker image to the registry
  168. @$(INFO) promoting $(SOURCE_TAG) to $(RELEASE_TAG)
  169. docker manifest inspect $(IMAGE_REGISTRY):$(SOURCE_TAG) > .tagmanifest
  170. for digest in $$(jq -r '.manifests[].digest' < .tagmanifest); do \
  171. docker pull $(IMAGE_REGISTRY)@$$digest; \
  172. done
  173. docker manifest create $(IMAGE_REGISTRY):$(RELEASE_TAG) \
  174. $$(jq -j '"--amend $(IMAGE_REGISTRY)@" + .manifests[].digest + " "' < .tagmanifest)
  175. docker manifest push $(IMAGE_REGISTRY):$(RELEASE_TAG)
  176. @$(OK) docker push $(RELEASE_TAG) \
  177. # ====================================================================================
  178. # Help
  179. # only comments after make target name are shown as help text
  180. help: ## Displays this help message
  181. @echo -e "$$(grep -hE '^\S+:.*##' $(MAKEFILE_LIST) | sed -e 's/:.*##\s*/:/' -e 's/^\(.\+\):\(.*\)/\\x1b[36m\1\\x1b[m:\2/' | column -c2 -t -s : | sort)"